
/*------------ PROTOCOLLO ALHOA con acknowledge (ULTIMA MODIFICA)-------------------*/


#include <stdlib.h>/*per exit(), rand(), .......    */
#include <iostream.h> /* per NULL   */
#include <math.h> /* per le funzioni per la creazione della topologia */
#include <time.h>
int simul_time;  /* per la chiamata delle funzioni */
int next_tx_time;
static int pkt_try_to_send_dir,pkt_try_to_send_bro , pkt_arrived_dir,pkt_arrived_bro,pkt_b_not,pktb_tra,data_tra,ack_tra,enter_xmitack,ack_arrived;
const int MAX_NUM_RTX = 4;
const int  T_MAX =1 ;
const int L_DATA = 25/*T_MAX*/;  //    LUNGHEZZA DEL PACCHETTO DATI(sia direct che broad)
const int L_ACK = 12;
const int L_PKT_B = 25;
const int MAX_AREA = 10;
const float R_MAX = 2.0;
const int DELTA_TIME =1 /*T_MAX*/; /*intervallo tra due possibili tx successive */
float tot_dir_th,second_dir_th;
float tot_bro_th;
enum CHANNEL_STATE {idle, busy};
enum FLAG {n,y};
enum NODE_STATE { n_passive, n_xmitdata,n_ackwait,n_xmitack,n_xmitpktb, n_receivepkt };
enum PKT_TO_SEND {not ,yes };
enum PKT_RIC {r_data , r_pkt_b,r_ack, r_noise};
enum KIND_SGN { direct , broadcast };
enum PKT_READY_TO_SEND {no , si}; /* ???????????????????????????????? */
enum SET_FLAG {not_ok , ok};  /* per generazione nodo che deve tx */
PKT_READY_TO_SEND pkt_ready ;/* per la generazione degli eventi tx */
KIND_SGN sgn;
SET_FLAG set_tx_flag,one_bro;/* per generazione nodi che tx */

class channel
 {
  public :
   CHANNEL_STATE state;
 };

class nodo
{
 public :
  NODE_STATE n_state;
  int  node_id;
  int num_vicini;
  int coord_x,coord_y;
  int pkt_ric_id; /* indica il campo del pkt con l'id della dest. */
  int dest_node_id; /* indica il nodo dest. del pkt       */
  int L_NOISE;
  int timer,timer2,remote_time,num_rtx;
  PKT_TO_SEND pkt_to_tx;
  KIND_SGN kind_of_sgn;
  FLAG dflag,flag ,flag2 , flag3 ,flag4, wait_flag, pkt_b_ok,broad_ok,attesa_ack_flag; // DA VERIFICARE SE NE OCCORRONO ALTRI
  PKT_RIC kind_pkt_ric/*, initial_pkt_ric*/;
  int* vett_vicini;
  channel ccch;// DA VERIFICARE IL MECCANISMO DI RISPOSTE A BROADCAST
 };

/*------------------------fine definizioni---------------------------------*/
/*-------------- inserimento prototipi delle funzioni ---------------------*/

void passive(nodo*,int);
void xmit_data(nodo*,int);
void ack_wait(nodo*,int);
void xmit_pkt_b(nodo*,int);
void receive_pkt(nodo*,int);
void xmit_ack(nodo*,int);
/*----------------- FINE DEI PROTOTIPI DLLE FUNZ. DEL PROTOCOLLO -------------*/

/*---FUNZIONI PER LA CREAZIONE DEL VETTORE DEI NODI E SUA INIZIALIZZAZIONE----*/
/*---- FUNZIONI NECESSARIE NELLE PROCEDURE SEGUENTI --------------------*/

float node_distance(nodo* n1, nodo* n2)
{
 float distance;
 int k,m,n,l;
 k = (n1->coord_x);
 m = (n2->coord_x);
 n = (n1->coord_y);
 l = (n2->coord_y);
 distance = sqrt( pow((k-m), 2) +pow((n-l), 2));
 return distance;
}

/*-------------- FINE FUNZIONI AUSILIARIE --------------------------*/


/*-------- PROCEDURA DI CREAZIONE DEL VETTORE DEI NODI ------------*/

nodo* crea_vettore_rete(int numero_nodi)
{
 int i;
 nodo* p = new nodo[numero_nodi];
 if( p== NULL)
 {
  cout << "non  stata allocata memoria per p. \n";
  exit(EXIT_FAILURE);
 }
 for(i=0;i<numero_nodi;i++) // fase inizializzazione dei campi del
 {                          // del vettore dei nodi escluse le coord
  (p+i)->node_id = i;
  (p+i)->n_state = n_passive;
  (p+i)->timer = 0;
  (p+i)->timer2 = 0;
  (p+i)->pkt_to_tx = not;
  (p+i)->flag = n;
  (p+i)->flag2 = n;
  (p+i)->flag3 = n;
  (p+i)->attesa_ack_flag = n;
  (p+i)->num_rtx = 0;
  (p+i)->flag4 = n;
  (p+i)->pkt_b_ok = n;
  (p+i)->broad_ok = n;
  (p+i)->wait_flag = n;
  (p+i)->ccch.state = idle;
 }
 return p;
}

/*------------- FINE CREAZIONE DEL VETTORE DEI NODI -------------------*/


/*-------- PROCEDURA DI CREAZIONE DELLA TOPOLOGIA -------------------*/
/* ------ NUOVA PROCEDURA DI ASSEGNAZIONE DELLE COORDINATE-----------*/

void assign_coordinate(nodo* p, int numero_nodi)
{
 int i , j , num_nodi_act = 0;
 int* matrix;
 matrix = new int[(MAX_AREA)*(MAX_AREA)];
 if( matrix == NULL )
 {
  cout << "memoria non allocata per matrix. \n";
  exit(EXIT_FAILURE);
 }
 for(i=0;i<MAX_AREA;i++)
 {
  for(j=0;j<MAX_AREA;j++)
   *(matrix +i*MAX_AREA + j) = 0;  // INIZIALIZZAZIONE DELLA MATRICE
 } // FINE CICLI DI INIZIALIZZAZIONE
 randomize();// messo qui il tempo per la generazione delle coord  molto minore
 while(num_nodi_act < numero_nodi)
 {
//  temp = rand_interval(0,4);
  i = random(MAX_AREA);   // RESTITUISCE INTERO TRA 0 E (MAX_AREA-1)
  j = random(MAX_AREA);
  if(*(matrix +i*MAX_AREA + j) == 0)   // CREAZIONE MATRICE RANDOM
  {                                    // PER L'ASSEGNAZIONE DELLE COORDINATE
   *(matrix + i*MAX_AREA +j) = 1;
   num_nodi_act ++;
  }
 }
 num_nodi_act = 0;
 do
 {
  for(i=0;i<MAX_AREA;i++)
  {
   for(j=0;j<MAX_AREA;j++)
   {
    if(*(matrix + i*MAX_AREA  + j) == 1)
    {
     (p + num_nodi_act)->coord_x = i;
     (p + num_nodi_act)->coord_y = j;
     num_nodi_act ++;
    }
   }
  }
 } // FINE BLOCCO DO
 while(num_nodi_act < numero_nodi); // FINE ASSEGNAZIONE COORDINATE
 delete(matrix);
}

/*---- FINE DELLA PROCEDURA DI ASSEGNAZIONE DELLE COORDINATE --------*/

/*------- PROCEDURA PER RIEMPIMENTO CAMPI DEL VETT_VICINI ---------------*/


void make_vett_vicini(nodo* p, int numero_nodi)
{
 int i,tot_vicini,j,temp;
 for(i=0;i<numero_nodi;i++)
 {
  tot_vicini=0;
  for(j=0;j<numero_nodi;j++)
  {
   if(i != j)
   {
    if(node_distance((p+i) , (p+j)) <= R_MAX )
     tot_vicini++;
   }
  } // del for j
  (p+i)->num_vicini = tot_vicini;
  if(tot_vicini >= 1)                           // SE k> 0 NON VIENE ALLOCATO IL VETTORE DEI VICINI
  {                                    // IL CONTROLL0 VA ESEGUITO OGNI VOLTA CHE SI DEVONO ATTIVARE I CAMPI
   (p+i)->vett_vicini = new int[tot_vicini]; // DEI VICINI SIA in tx che in rx
   temp=(tot_vicini-1);
   for(j=0;j<numero_nodi;j++)
   {
    if(i != j)
    {
     if(node_distance((p+i) , (p+j)) <= R_MAX )
     {
      (p+i)->vett_vicini[temp] = j;
      temp--;
     }
    } //del if i != j
   } // del for j
  } // del if k>=1
 }// del for i
} // fine make_vett

/*------- FINE PROCEDURA RIEMPIMENTO VETT_VICINI PER TUTTI I NODI --------*/

/*-- PROCEDURE VERE E PROPRIE DELL'ACCESSO DI TIPO CSMA -------------------*/

void passive(nodo* p, int nid)
{
 (p+nid)->n_state = n_passive;
 if(((p+nid)->ccch.state == idle)&&((p+nid)->pkt_to_tx == not))
 {
  (p+nid)->wait_flag = y;
  return;
 }
 else if((p+nid)->ccch.state == busy)
 {
  (p+nid)->flag = n;
  receive_pkt(p,nid);//   PER LA RICEZIONE DI QUELLO CHE C'E SUL CANALE
 }
 else // PKT_TO_TX
 {
  if((p+nid)->kind_of_sgn == direct)
  {
   (p+nid)->flag = n;// ora si puo' scongelare il timer per la prossima tx
   xmit_data(p,nid);
  }
  else // sgn broad
  {
   (p+nid)->flag = n;
   xmit_pkt_b(p,nid);
  }
 }// fine timer scaduto
} // FINE PROCEDURA DI ATTESA


/* --------------- PROCEDURA DI XMIT_DATA ---------------------------------*/

void xmit_data(nodo* p, int nid)
{
 int t,q;
 (p+nid)->n_state = n_xmitdata;
 if((p+nid)->flag == n)
 {
  (p+nid)->timer = simul_time + L_DATA;
  (p+nid)->ccch.state = busy;
  (p+nid)->kind_pkt_ric = r_data;
  (p+nid)->L_NOISE = (L_DATA-1);
  (p+nid)->flag = y;
  (p+nid)->wait_flag = y;
  return;
 }
 if(simul_time < (p+nid)->timer)
 {
  if((p+nid)->flag2 == n)
  {
   for(t=0;t<(p+nid)->num_vicini;t++)// TRASMISSIONE DATA (FASE 2)
   {
    q = (p+nid)->vett_vicini[t];
    if((p+q)->ccch.state == busy)
    {
     (p+q)->kind_pkt_ric = r_noise;
     if((p+q)->L_NOISE < L_DATA)
      (p+q)->L_NOISE = L_DATA;
    }
    else // ccch idle
    {
     (p+q)->ccch.state = busy;
     (p+q)->kind_pkt_ric = r_data;
     (p+q)->pkt_ric_id = (p+nid)->dest_node_id;
    }
   }// fine del ciclo for
   (p+nid)->flag2 = y;
  } // fine dell'if flag2
  (p+nid)->L_NOISE --;// VA COMUNQUE FATTO PER TENERE AGGIORNATO PER QUANTO IL
  (p+nid)->wait_flag = y; // CCCH VERRA' PERCEPITO OCCUPATO
  return;
 }// FINITA LA TRASMISSIONE DEL DATA
 if((p+nid)->kind_pkt_ric == r_data)
 {
  (p+nid)->ccch.state = idle;
  (p+nid)->L_NOISE = 0;
 }
 data_tra ++;
 (p+nid)->flag = n;
 (p+nid)->flag2 = n;
 ack_wait(p,nid);
}
 /*---------------------FINE PROCEDURA DI TRASMISSIONE DEL DATA ------------*/


/*-------- PROCEDURA DI ATTESA DELL' ACK -----------------------------------*/

void ack_wait(nodo* p,int nid)
{
 (p+nid)->n_state = n_ackwait;
 if((p+nid)->flag == n)
 {
  (p+nid)->timer = simul_time + (4*T_MAX);
  (p+nid)->flag = y;
 }
 if(((p+nid)->ccch.state == idle)&&(simul_time <= (p+nid)->timer))
 {
  (p+nid)->wait_flag = y;
  return;
 }
 else if(simul_time > (p+nid)->timer)
 {
  (p+nid)->attesa_ack_flag = n;
  (p+nid)->flag = n;
  if((p+nid)->num_rtx < MAX_NUM_RTX)
  {
   (p+nid)->num_rtx ++;
   passive(p,nid);
  }
  else
  {
   (p+nid)->num_rtx = 0;
   (p+nid)->pkt_to_tx = not;
   passive(p,nid);
  }
 }
 else // ccch.state = busy
 {
  (p+nid)->attesa_ack_flag = y;
  (p+nid)->flag = n;
  receive_pkt(p,nid);
 }
}//---------------------------- FINE PROCEDURA ------------------------




/*------------------PROCEDURA DI TX DELL' ACK---------------------------*/
void xmit_ack(nodo* p, int nid)
{
 int t,q;
 (p+nid)->n_state = n_xmitack;
 if((p+nid)->flag == n)
 {
  enter_xmitack ++;
  (p+nid)->timer = simul_time + L_ACK;
  (p+nid)->ccch.state = busy;
  (p+nid)->kind_pkt_ric = r_ack;
  (p+nid)->L_NOISE = (L_ACK-1);
  (p+nid)->flag = y;
  (p+nid)->wait_flag = y;
  return;
 }
 if(simul_time < (p+nid)->timer)
 {
  if((p+nid)->flag2 == n)
  {
   for(t=0;t<(p+nid)->num_vicini;t++)// TRASMISSIONE ACK (FASE 2)
   {
    q =(p+nid)->vett_vicini[t];
    if((p+q)->ccch.state == busy)
    {
     (p+q)->kind_pkt_ric = r_noise;
     if((p+q)->L_NOISE < L_ACK)
      (p+q)->L_NOISE = L_ACK;
    }
    else // ccch idle
    {
     (p+q)->ccch.state = busy;
     (p+q)->kind_pkt_ric = r_ack;
     (p+q)->pkt_ric_id = (p+nid)->node_id;
    }
   }// fine del ciclo for
   (p+nid)->flag2 = y;
  } // fine dell'if flag2
  (p+nid)->L_NOISE --;
  (p+nid)->wait_flag = y;
  return;
 }// FINITA LA TRASMISSIONE DEL ACK(FASE1 + FASE2)
 ack_tra ++;
 if((p+nid)->kind_pkt_ric == r_ack)
 {
  (p+nid)->ccch.state = idle;
  (p+nid)->L_NOISE = 0;
 }
 (p+nid)->flag = n;
 (p+nid)->flag2 = n;
 passive(p,nid);
}/*----- FINE PROCEDURA -----------------------------------------------*/


/*--------- PROCEDURA XMIT_PKT_B -----------------------------------------*/

void xmit_pkt_b(nodo* p, int nid)
{
 int t,q;
 (p+nid)->n_state = n_xmitpktb;
 if((p+nid)->flag == n)
 {
  (p+nid)->ccch.state = busy;
  (p+nid)->kind_pkt_ric = r_pkt_b;
  (p+nid)->timer = simul_time + L_PKT_B+ 2*T_MAX;
  (p+nid)->L_NOISE = (L_PKT_B - 1);
  (p+nid)->broad_ok = y;
  (p+nid)->flag = y;
  (p+nid)->wait_flag = y;
  return;
 }
 if(simul_time < (p+nid)->timer)
 {
  if((p+nid)->flag2 == n)
  {
   for(t=0;t<(p+nid)->num_vicini;t++)// TRASMISSIONE PKT_B (FASE 2)
   {
    q = (p+nid)->vett_vicini[t];
    if((p+q)->ccch.state == busy)
    {
     (p+q)->kind_pkt_ric = r_noise;
     if((p+q)->L_NOISE < L_PKT_B)
      (p+q)->L_NOISE = L_PKT_B;
    }
    else // ccch idle
    {
     (p+q)->ccch.state = busy;
     (p+q)->kind_pkt_ric = r_pkt_b;
    }
   }// fine del ciclo for
   (p+nid)->flag2 = y;
  } // fine dell'if flag2
  (p+nid)->L_NOISE --;// VA COMUNQUE FATTO PER TENERE AGGIORNATO PER QUANTO IL
  (p+nid)->wait_flag = y; // CCCH VERRA' PERCEPITO OCCUPATO
  return;
 }// FINITA LA TRASMISSIONE DEL PKT_B (FASE1 + FASE2)
 pktb_tra ++;
 for(t=0;t<(p+nid)->num_vicini;t++)
 {
  q = (p+nid)->vett_vicini[t];
  if((p+q)->pkt_b_ok == n)
   (p+nid)->broad_ok = n;
 }// del for
 if((p+nid)->broad_ok == y)
   pkt_arrived_bro ++;
 else
   pkt_b_not ++;
 if((p+nid)->kind_pkt_ric == r_pkt_b)
 {
  (p+nid)->ccch.state = idle;
  (p+nid)->L_NOISE = 0;
 }
 (p+nid)->pkt_to_tx = not;
 (p+nid)->flag = n;
 (p+nid)->flag2 = n;
 passive(p,nid);
} /*--------------- FINE PROCEDURA DI TX  DEL PKT_B---------------------*/




/*-------------------PROCEDURA RECEIVE_PKT ----------------------------------*/

void receive_pkt(nodo*p , int nid)
{
 (p+nid)->n_state = n_receivepkt;
 if((p+nid)->flag == n)
 {
  switch((p+nid)->kind_pkt_ric)
  {
   case r_data :
   {
    (p+nid)->L_NOISE = L_DATA-1;
    (p+nid)->timer = simul_time + L_DATA;
    break;
   }
   case r_ack :
   {
    (p+nid)->L_NOISE = L_ACK-1;
    (p+nid)->timer = simul_time + L_ACK;
    break;
   }
   case r_pkt_b:
   {
    (p+nid)->L_NOISE = L_PKT_B-1;
    (p+nid)->pkt_b_ok = n;
    (p+nid)->timer = simul_time + L_PKT_B;
    break;
   }
   case r_noise:
   {
    (p+nid)->timer = simul_time + (p+nid)->L_NOISE;
    (p+nid)->L_NOISE --;
    break;
   }
  };//  FINE DELLO SWITCH
  (p+nid)->flag = y;
  (p+nid)->wait_flag = y;
  return;
 } // iniz. timer fatta
 if(simul_time < (p+nid)->timer)
 {
  if((p+nid)->kind_pkt_ric != r_noise)
  {
   (p+nid)->L_NOISE --;
   (p+nid)->wait_flag = y;
   return;
  }
  else
  {
   (p+nid)->timer = simul_time + (p+nid)->L_NOISE;
   (p+nid)->L_NOISE --;
   (p+nid)->wait_flag = y;
   return;
  }
 }// FINE DELLA RICEZIONE
 (p+nid)->ccch.state = idle;
 (p+nid)->L_NOISE = 0;
 switch((p+nid)->kind_pkt_ric)
 {
   case r_data :
   {
    if((p+nid)->attesa_ack_flag == y)
    {
     (p+nid)->flag = n;
     (p+nid)->attesa_ack_flag = n;
     if((p+nid)->num_rtx < MAX_NUM_RTX)
     {
      (p+nid)->num_rtx ++;
      passive(p,nid);
     }
     else
     {
      (p+nid)->num_rtx = 0;
      (p+nid)->pkt_to_tx = not;
      passive(p,nid);
     }
    }// fine caso di attesa del ack
    else// non si aspetta ack
    {
     if((p+nid)->pkt_ric_id ==(p+nid)->node_id)
     {
      pkt_arrived_dir ++;
      (p+nid)->flag = n;
      xmit_ack(p,nid);
     }
     else  // data non diretto al nodo
     {
      (p+nid)->flag = n;
      passive(p,nid);
     }
    }
    break;
   }
   case r_ack :
   {
    if((p+nid)->attesa_ack_flag == y)// voul dire che si viene da una tx di un data
    {
     if((p+nid)->pkt_ric_id == (p+nid)->dest_node_id)
     {
      (p+nid)->attesa_ack_flag = n;
      ack_arrived ++;
      (p+nid)->flag = n;
      (p+nid)->pkt_to_tx = not;
      passive(p,nid);                // quindi si attendeva ack
     }
    }
    else // ack non diretto al nodo che aspettava o non si stava aspettando ack
    {
     (p+nid)->flag = n;
     passive(p,nid);
    }
    break;
   }
   case r_pkt_b:
   {
    if((p+nid)->attesa_ack_flag == y)
    {
     (p+nid)->flag = n;
     (p+nid)->attesa_ack_flag = n;
     if((p+nid)->num_rtx < MAX_NUM_RTX)
     {
      (p+nid)->num_rtx ++;
      passive(p,nid);
     }
     else
     {
      (p+nid)->num_rtx = 0;
      (p+nid)->pkt_to_tx = not;
      passive(p,nid);
     }
    }// fine caso di attesa del ack
    else // non si attendeva ack
    {
     (p+nid)->pkt_b_ok = y; // settato ad n nella iniz. del timer di ricezione
     (p+nid)->flag = n;
     passive(p,nid);
    }
    break;
   }
   case r_noise:
   {
    if((p+nid)->attesa_ack_flag == y)
    {
     (p+nid)->flag = n;
     (p+nid)->attesa_ack_flag = n;
     if((p+nid)->num_rtx < MAX_NUM_RTX)
     {
      (p+nid)->num_rtx ++;
      passive(p,nid);
     }
     else
     {
      (p+nid)->num_rtx = 0;
      (p+nid)->pkt_to_tx = not;
      passive(p,nid);
     }
    }// fine caso di attesa del ack
    else // non si attendeva ack
    {
     (p+nid)->flag  = n;
     passive(p,nid);
    }
    break;
   }
 };//  FINE DELLO SWITCH
} /* FINE DELLA PROCEDURA DI RX DA REMOTE ----------------------------*/

/*---------------- PROCEDURA MAIN ---------------------------------------*/


int main()
{
 nodo* punt;
 int global_time , num_nodi,prova_fine;
 int a ,b ,i, c,w, temp2;
 cout << "inserisci il numero dei nodi : \n";
 cin >> num_nodi;
 if(num_nodi >= (MAX_AREA*MAX_AREA))
 {
  cout << " il numero dei nodi supera quello consentito che  di:\n" << (MAX_AREA*MAX_AREA);
  exit(EXIT_FAILURE);
 }
 cout << "inserisci il tempo di simulazione(in interi):\n";
 cin >> global_time;
 punt = crea_vettore_rete(num_nodi);  // CREAZIONE VERA E PROPRIA DELLA RETE
 assign_coordinate(punt , num_nodi);  // TRAMITE LE FUNZIONI DEFINITE
 make_vett_vicini(punt , num_nodi);   //ALL' INIZIO DEL FILE
 next_tx_time = 0;          //per la prima trasmissione
 for(simul_time = 0; simul_time <= global_time; simul_time++)
 {
  if(simul_time  >= next_tx_time)
  {
   int i,j, k=0;
   set_tx_flag = not_ok;
   temp2 =random(2);
   if(temp2 == 0)
    sgn = direct;
   else
    sgn = broadcast;
   for(i=0;i<num_nodi;i++)
   {
    one_bro = ok;
    if(((punt+i)->pkt_to_tx == not)&&((punt+i)->num_vicini > 0)&&(one_bro == ok))  // si potrebbe fare il controllo
     k++;                                                         // su p->pkt_to_tx se  yes
   }                                                              // non si attiva, se  not si
   if(k>0)                                                        // attiva
   {
    next_tx_time = simul_time + DELTA_TIME;
    do
    {
     a = random(num_nodi);// non arriva mai a num_nodi
     one_bro = ok;
     if(((punt+a)->pkt_to_tx == not)&&((punt+a)->num_vicini > 0)&&(one_bro == ok))// --punt  il punt che restituisce la funzione TOP_MATR--
     {
      set_tx_flag = ok;
      (punt+a)->pkt_to_tx = yes;
      if( sgn == broadcast )
      {
       (punt+a)->kind_of_sgn = broadcast;
       pkt_try_to_send_bro ++;// INCREMENTO DEL CONTATORE DI PKT_BRO MANDATI DA TX DALLO STRATO SUP
      }                       // ALLO STRATO MAC
      else // sgn  diretta
      {
       pkt_try_to_send_dir ++;// INCREMENTO DEL CONTATORE DI PKT_DATA MANDATI DA TX DALLO STRATO SUP
       (punt+a)->kind_of_sgn = direct;
       b = random((punt+a)->num_vicini);
       (punt+a)->dest_node_id = (punt+a)->vett_vicini[b];
      }
     }
    } // --blocco del do-while--
    while( set_tx_flag != ok );
   }// if k>0  -- SE K<0 NON GENERA UN EVENTO TX
  } //  fine dell' if simul_time > next_tx_time
  /* ------------inizio ciclo che scorre tutti i nodi------------ */
  /* ------------all'interno del for(simul_time)--------------- */
  /* ----- FINE PARTE PER EVENTUALE GENERAZIONE DI UN -------------*/
  /* ---------------- EVENTO TRASMISSIVO ---------------------------*/
  for( c=0; c<num_nodi ;c++) // --applicazione delle regole del protocollo per ogni nodo-----
  {
   if( (punt+c)->n_state == n_passive)
   {
    passive(punt,c);
    if( (punt+c)->wait_flag == y)
    {
     (punt+c)->wait_flag = n;
     continue;
    }
   }
   else if((punt+c)->n_state == n_xmitdata)
   {
    xmit_data(punt,c);
    if((punt+c)->wait_flag == y)
    {
     (punt+c)->wait_flag = n;
     continue;
    }
   }
   else if((punt+c)->n_state == n_ackwait)
   {
    ack_wait(punt,c);
    if((punt+c)->wait_flag == y)
    {
     (punt+c)->wait_flag = n;
     continue;
    }
   }
   else if((punt+c)->n_state == n_receivepkt)
   {
    receive_pkt(punt,c);
    if((punt+c)->wait_flag == y)
    {
     (punt+c)->wait_flag = n;
     continue;
    }
   }
   else if((punt+c)->n_state == n_xmitack)
   {
    xmit_ack(punt,c);
    if((punt+c)->wait_flag == y)
    {
     (punt+c)->wait_flag = n;
     continue;
    }
   }
   else if((punt+c)->n_state == n_xmitpktb)
   {
    xmit_pkt_b(punt,c);
    if((punt+c)->wait_flag == y)
    {
     (punt+c)->wait_flag = n;
     continue;
    }
   }
  } /* ---------fine ciclo for che scorre tutti i nodi ?????---------- */
/* ------------------------------------------------------------------- */
/* ------------------------------------------------------------------- */
/* -------- altre istruzioni nel ciclo di simul_time---------------- */
/* ------------------------------------------------------------------- */
/* ------------------------------------------------------------------- */
 } /* -------fine ciclo simul_time---------------------------------- */
 tot_bro_th = (float)pkt_arrived_bro/pkt_try_to_send_bro;
 tot_dir_th = (float)ack_arrived/pkt_try_to_send_dir;
 second_dir_th = (float)pkt_arrived_dir/pkt_try_to_send_dir;
/* ------------------------------------------------------------------- */
/* ------------------istruzioni per output della simul.--------------- */
 cout << "il num di pkt broad da trasmettere/num pkt broad arrivati e' : "  <<pkt_try_to_send_bro <<"/" <<pkt_arrived_bro << "\n"<<
         "il th totale di broadcast e' : "<< tot_bro_th<<"\n"<<
	      "il num di broad tentati (pkt_b trasmessi) e' : "<<pktb_tra <<"\n" <<
         "il num di bro no arrivati a tutti e' : "<< pkt_b_not <<"\n" <<
         "il num di pkt dir cercati di trasmettere/num pkt dir arrivati  e' : " << pkt_try_to_send_dir <<"/"<<pkt_arrived_dir  << "\n" <<
         "il th totale di direct e' : " << tot_dir_th << "\n" <<
         "il th dir (senza ACK ) e' :"<< second_dir_th << "\n" <<
         "il num di tra data terminate e' : "<< data_tra <<"\n" <<
         "il num di ack arrivati e' :"<<ack_arrived<<"\n"<<
         "le volte che e' entrata xmit_ack :"<<enter_xmitack<<"\n";
 delete(punt);
 cin >> prova_fine;
 while(prova_fine != 0)
   ;
 return(0);
}  /* -----------------fine della main--------------------------------*/

